/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(MEDIA_CONTROLS_SCRIPT)

#include "JSMediaControlsHost.h"

#include "ActiveDOMObject.h"
#include "DOMIsoSubspaces.h"
#include "JSAudioTrack.h"
#include "JSAudioTrackList.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMConvertUnion.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMOperation.h"
#include "JSDOMWrapperCache.h"
#include "JSHTMLElement.h"
#include "JSTextTrack.h"
#include "JSTextTrackList.h"
#include "RuntimeEnabledFeatures.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSArray.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/JSString.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>
#include <wtf/Variant.h>

#if ENABLE(MEDIA_CONTROLS_CONTEXT_MENUS)
#include "JSDOMConvertCallbacks.h"
#include "JSDOMConvertJSON.h"
#include "JSVoidCallback.h"
#endif


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(MediaControlsHost::DeviceType enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("none"),
        MAKE_STATIC_STRING_IMPL("airplay"),
        MAKE_STATIC_STRING_IMPL("tvout"),
    };
    static_assert(static_cast<size_t>(MediaControlsHost::DeviceType::None) == 0, "MediaControlsHost::DeviceType::None is not 0 as expected");
    static_assert(static_cast<size_t>(MediaControlsHost::DeviceType::Airplay) == 1, "MediaControlsHost::DeviceType::Airplay is not 1 as expected");
    static_assert(static_cast<size_t>(MediaControlsHost::DeviceType::Tvout) == 2, "MediaControlsHost::DeviceType::Tvout is not 2 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(JSGlobalObject& lexicalGlobalObject, MediaControlsHost::DeviceType enumerationValue)
{
    return jsStringWithCache(lexicalGlobalObject.vm(), convertEnumerationToString(enumerationValue));
}

template<> Optional<MediaControlsHost::DeviceType> parseEnumeration<MediaControlsHost::DeviceType>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto stringValue = value.toWTFString(&lexicalGlobalObject);
    if (stringValue == "none")
        return MediaControlsHost::DeviceType::None;
    if (stringValue == "airplay")
        return MediaControlsHost::DeviceType::Airplay;
    if (stringValue == "tvout")
        return MediaControlsHost::DeviceType::Tvout;
    return WTF::nullopt;
}

template<> const char* expectedEnumerationValues<MediaControlsHost::DeviceType>()
{
    return "\"none\", \"airplay\", \"tvout\"";
}

// Functions

static JSC_DECLARE_HOST_FUNCTION(jsMediaControlsHostPrototypeFunction_sortedTrackListForMenu);
static JSC_DECLARE_HOST_FUNCTION(jsMediaControlsHostPrototypeFunction_displayNameForTrack);
static JSC_DECLARE_HOST_FUNCTION(jsMediaControlsHostPrototypeFunction_setSelectedTextTrack);
static JSC_DECLARE_HOST_FUNCTION(jsMediaControlsHostPrototypeFunction_updateTextTrackContainer);
static JSC_DECLARE_HOST_FUNCTION(jsMediaControlsHostPrototypeFunction_enteredFullscreen);
static JSC_DECLARE_HOST_FUNCTION(jsMediaControlsHostPrototypeFunction_exitedFullscreen);
static JSC_DECLARE_HOST_FUNCTION(jsMediaControlsHostPrototypeFunction_generateUUID);
static JSC_DECLARE_HOST_FUNCTION(jsMediaControlsHostPrototypeFunction_base64StringForIconNameAndType);
static JSC_DECLARE_HOST_FUNCTION(jsMediaControlsHostPrototypeFunction_formattedStringForDuration);
#if ENABLE(MEDIA_CONTROLS_CONTEXT_MENUS)
static JSC_DECLARE_HOST_FUNCTION(jsMediaControlsHostPrototypeFunction_showMediaControlsContextMenu);
#endif

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsMediaControlsHost_captionMenuOffItem);
static JSC_DECLARE_CUSTOM_GETTER(jsMediaControlsHost_captionMenuAutomaticItem);
static JSC_DECLARE_CUSTOM_GETTER(jsMediaControlsHost_captionDisplayMode);
static JSC_DECLARE_CUSTOM_GETTER(jsMediaControlsHost_textTrackContainer);
static JSC_DECLARE_CUSTOM_GETTER(jsMediaControlsHost_allowsInlineMediaPlayback);
static JSC_DECLARE_CUSTOM_GETTER(jsMediaControlsHost_supportsFullscreen);
static JSC_DECLARE_CUSTOM_GETTER(jsMediaControlsHost_isVideoLayerInline);
static JSC_DECLARE_CUSTOM_GETTER(jsMediaControlsHost_userGestureRequired);
static JSC_DECLARE_CUSTOM_GETTER(jsMediaControlsHost_isInMediaDocument);
static JSC_DECLARE_CUSTOM_GETTER(jsMediaControlsHost_shouldForceControlsDisplay);
static JSC_DECLARE_CUSTOM_GETTER(jsMediaControlsHost_compactMode);
static JSC_DECLARE_CUSTOM_GETTER(jsMediaControlsHost_externalDeviceDisplayName);
static JSC_DECLARE_CUSTOM_GETTER(jsMediaControlsHost_externalDeviceType);
static JSC_DECLARE_CUSTOM_GETTER(jsMediaControlsHost_controlsDependOnPageScaleFactor);
static JSC_DECLARE_CUSTOM_SETTER(setJSMediaControlsHost_controlsDependOnPageScaleFactor);
static JSC_DECLARE_CUSTOM_GETTER(jsMediaControlsHost_shadowRootCSSText);

class JSMediaControlsHostPrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSMediaControlsHostPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSMediaControlsHostPrototype* ptr = new (NotNull, JSC::allocateCell<JSMediaControlsHostPrototype>(vm.heap)) JSMediaControlsHostPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSMediaControlsHostPrototype, Base);
        return &vm.plainObjectSpace;
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSMediaControlsHostPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSMediaControlsHostPrototype, JSMediaControlsHostPrototype::Base);

/* Hash table for prototype */

static const HashTableValue JSMediaControlsHostPrototypeTableValues[] =
{
    { "captionMenuOffItem", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaControlsHost_captionMenuOffItem), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "captionMenuAutomaticItem", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaControlsHost_captionMenuAutomaticItem), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "captionDisplayMode", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaControlsHost_captionDisplayMode), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "textTrackContainer", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaControlsHost_textTrackContainer), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "allowsInlineMediaPlayback", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaControlsHost_allowsInlineMediaPlayback), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "supportsFullscreen", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaControlsHost_supportsFullscreen), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "isVideoLayerInline", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaControlsHost_isVideoLayerInline), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "userGestureRequired", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaControlsHost_userGestureRequired), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "isInMediaDocument", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaControlsHost_isInMediaDocument), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "shouldForceControlsDisplay", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaControlsHost_shouldForceControlsDisplay), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "compactMode", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaControlsHost_compactMode), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "externalDeviceDisplayName", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaControlsHost_externalDeviceDisplayName), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "externalDeviceType", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaControlsHost_externalDeviceType), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "controlsDependOnPageScaleFactor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaControlsHost_controlsDependOnPageScaleFactor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMediaControlsHost_controlsDependOnPageScaleFactor) } },
    { "shadowRootCSSText", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaControlsHost_shadowRootCSSText), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "sortedTrackListForMenu", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsMediaControlsHostPrototypeFunction_sortedTrackListForMenu), (intptr_t) (1) } },
    { "displayNameForTrack", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsMediaControlsHostPrototypeFunction_displayNameForTrack), (intptr_t) (1) } },
    { "setSelectedTextTrack", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsMediaControlsHostPrototypeFunction_setSelectedTextTrack), (intptr_t) (1) } },
    { "updateTextTrackContainer", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsMediaControlsHostPrototypeFunction_updateTextTrackContainer), (intptr_t) (0) } },
    { "enteredFullscreen", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsMediaControlsHostPrototypeFunction_enteredFullscreen), (intptr_t) (0) } },
    { "exitedFullscreen", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsMediaControlsHostPrototypeFunction_exitedFullscreen), (intptr_t) (0) } },
    { "generateUUID", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsMediaControlsHostPrototypeFunction_generateUUID), (intptr_t) (0) } },
    { "base64StringForIconNameAndType", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsMediaControlsHostPrototypeFunction_base64StringForIconNameAndType), (intptr_t) (2) } },
    { "formattedStringForDuration", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsMediaControlsHostPrototypeFunction_formattedStringForDuration), (intptr_t) (1) } },
#if ENABLE(MEDIA_CONTROLS_CONTEXT_MENUS)
    { "showMediaControlsContextMenu", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsMediaControlsHostPrototypeFunction_showMediaControlsContextMenu), (intptr_t) (3) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
};

const ClassInfo JSMediaControlsHostPrototype::s_info = { "MediaControlsHost", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSMediaControlsHostPrototype) };

void JSMediaControlsHostPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSMediaControlsHost::info(), JSMediaControlsHostPrototypeTableValues, *this);
    bool hasDisabledRuntimeProperties = false;
    if (!RuntimeEnabledFeatures::sharedFeatures().modernMediaControlsEnabled()) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("base64StringForIconNameAndType"), strlen("base64StringForIconNameAndType"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (!RuntimeEnabledFeatures::sharedFeatures().modernMediaControlsEnabled()) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("formattedStringForDuration"), strlen("formattedStringForDuration"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
#if ENABLE(MEDIA_CONTROLS_CONTEXT_MENUS)
    if (!(jsCast<JSDOMGlobalObject*>(globalObject())->scriptExecutionContext()->settingsValues().mediaControlsContextMenusEnabled && RuntimeEnabledFeatures::sharedFeatures().modernMediaControlsEnabled())) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("showMediaControlsContextMenu"), strlen("showMediaControlsContextMenu"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
#endif
    if (!RuntimeEnabledFeatures::sharedFeatures().modernMediaControlsEnabled()) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("shadowRootCSSText"), strlen("shadowRootCSSText"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
    if (hasDisabledRuntimeProperties && structure()->isDictionary())
        flattenDictionaryObject(vm);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSMediaControlsHost::s_info = { "MediaControlsHost", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSMediaControlsHost) };

JSMediaControlsHost::JSMediaControlsHost(Structure* structure, JSDOMGlobalObject& globalObject, Ref<MediaControlsHost>&& impl)
    : JSDOMWrapper<MediaControlsHost>(structure, globalObject, WTFMove(impl))
{
}

void JSMediaControlsHost::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

    static_assert(!std::is_base_of<ActiveDOMObject, MediaControlsHost>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

}

JSObject* JSMediaControlsHost::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSMediaControlsHostPrototype::create(vm, &globalObject, JSMediaControlsHostPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSMediaControlsHost::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSMediaControlsHost>(vm, globalObject);
}

void JSMediaControlsHost::destroy(JSC::JSCell* cell)
{
    JSMediaControlsHost* thisObject = static_cast<JSMediaControlsHost*>(cell);
    thisObject->JSMediaControlsHost::~JSMediaControlsHost();
}

template<> inline JSMediaControlsHost* IDLAttribute<JSMediaControlsHost>::cast(JSGlobalObject& lexicalGlobalObject, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSMediaControlsHost*>(JSC::getVM(&lexicalGlobalObject), JSValue::decode(thisValue));
}

template<> inline JSMediaControlsHost* IDLOperation<JSMediaControlsHost>::cast(JSGlobalObject& lexicalGlobalObject, CallFrame& callFrame)
{
    return jsDynamicCast<JSMediaControlsHost*>(JSC::getVM(&lexicalGlobalObject), callFrame.thisValue());
}

static inline JSValue jsMediaControlsHost_captionMenuOffItemGetter(JSGlobalObject& lexicalGlobalObject, JSMediaControlsHost& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<TextTrack>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.captionMenuOffItem())));
}

JSC_DEFINE_CUSTOM_GETTER(jsMediaControlsHost_captionMenuOffItem, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMediaControlsHost>::get<jsMediaControlsHost_captionMenuOffItemGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "captionMenuOffItem");
}

static inline JSValue jsMediaControlsHost_captionMenuAutomaticItemGetter(JSGlobalObject& lexicalGlobalObject, JSMediaControlsHost& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<TextTrack>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.captionMenuAutomaticItem())));
}

JSC_DEFINE_CUSTOM_GETTER(jsMediaControlsHost_captionMenuAutomaticItem, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMediaControlsHost>::get<jsMediaControlsHost_captionMenuAutomaticItemGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "captionMenuAutomaticItem");
}

static inline JSValue jsMediaControlsHost_captionDisplayModeGetter(JSGlobalObject& lexicalGlobalObject, JSMediaControlsHost& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLDOMString>(lexicalGlobalObject, throwScope, impl.captionDisplayMode())));
}

JSC_DEFINE_CUSTOM_GETTER(jsMediaControlsHost_captionDisplayMode, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMediaControlsHost>::get<jsMediaControlsHost_captionDisplayModeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "captionDisplayMode");
}

static inline JSValue jsMediaControlsHost_textTrackContainerGetter(JSGlobalObject& lexicalGlobalObject, JSMediaControlsHost& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<HTMLElement>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.textTrackContainer())));
}

JSC_DEFINE_CUSTOM_GETTER(jsMediaControlsHost_textTrackContainer, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMediaControlsHost>::get<jsMediaControlsHost_textTrackContainerGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "textTrackContainer");
}

static inline JSValue jsMediaControlsHost_allowsInlineMediaPlaybackGetter(JSGlobalObject& lexicalGlobalObject, JSMediaControlsHost& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLBoolean>(lexicalGlobalObject, throwScope, impl.allowsInlineMediaPlayback())));
}

JSC_DEFINE_CUSTOM_GETTER(jsMediaControlsHost_allowsInlineMediaPlayback, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMediaControlsHost>::get<jsMediaControlsHost_allowsInlineMediaPlaybackGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "allowsInlineMediaPlayback");
}

static inline JSValue jsMediaControlsHost_supportsFullscreenGetter(JSGlobalObject& lexicalGlobalObject, JSMediaControlsHost& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLBoolean>(lexicalGlobalObject, throwScope, impl.supportsFullscreen())));
}

JSC_DEFINE_CUSTOM_GETTER(jsMediaControlsHost_supportsFullscreen, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMediaControlsHost>::get<jsMediaControlsHost_supportsFullscreenGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "supportsFullscreen");
}

static inline JSValue jsMediaControlsHost_isVideoLayerInlineGetter(JSGlobalObject& lexicalGlobalObject, JSMediaControlsHost& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLBoolean>(lexicalGlobalObject, throwScope, impl.isVideoLayerInline())));
}

JSC_DEFINE_CUSTOM_GETTER(jsMediaControlsHost_isVideoLayerInline, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMediaControlsHost>::get<jsMediaControlsHost_isVideoLayerInlineGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "isVideoLayerInline");
}

static inline JSValue jsMediaControlsHost_userGestureRequiredGetter(JSGlobalObject& lexicalGlobalObject, JSMediaControlsHost& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLBoolean>(lexicalGlobalObject, throwScope, impl.userGestureRequired())));
}

JSC_DEFINE_CUSTOM_GETTER(jsMediaControlsHost_userGestureRequired, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMediaControlsHost>::get<jsMediaControlsHost_userGestureRequiredGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "userGestureRequired");
}

static inline JSValue jsMediaControlsHost_isInMediaDocumentGetter(JSGlobalObject& lexicalGlobalObject, JSMediaControlsHost& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLBoolean>(lexicalGlobalObject, throwScope, impl.isInMediaDocument())));
}

JSC_DEFINE_CUSTOM_GETTER(jsMediaControlsHost_isInMediaDocument, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMediaControlsHost>::get<jsMediaControlsHost_isInMediaDocumentGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "isInMediaDocument");
}

static inline JSValue jsMediaControlsHost_shouldForceControlsDisplayGetter(JSGlobalObject& lexicalGlobalObject, JSMediaControlsHost& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLBoolean>(lexicalGlobalObject, throwScope, impl.shouldForceControlsDisplay())));
}

JSC_DEFINE_CUSTOM_GETTER(jsMediaControlsHost_shouldForceControlsDisplay, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMediaControlsHost>::get<jsMediaControlsHost_shouldForceControlsDisplayGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "shouldForceControlsDisplay");
}

static inline JSValue jsMediaControlsHost_compactModeGetter(JSGlobalObject& lexicalGlobalObject, JSMediaControlsHost& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLBoolean>(lexicalGlobalObject, throwScope, impl.compactMode())));
}

JSC_DEFINE_CUSTOM_GETTER(jsMediaControlsHost_compactMode, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMediaControlsHost>::get<jsMediaControlsHost_compactModeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "compactMode");
}

static inline JSValue jsMediaControlsHost_externalDeviceDisplayNameGetter(JSGlobalObject& lexicalGlobalObject, JSMediaControlsHost& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLDOMString>(lexicalGlobalObject, throwScope, impl.externalDeviceDisplayName())));
}

JSC_DEFINE_CUSTOM_GETTER(jsMediaControlsHost_externalDeviceDisplayName, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMediaControlsHost>::get<jsMediaControlsHost_externalDeviceDisplayNameGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "externalDeviceDisplayName");
}

static inline JSValue jsMediaControlsHost_externalDeviceTypeGetter(JSGlobalObject& lexicalGlobalObject, JSMediaControlsHost& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLEnumeration<MediaControlsHost::DeviceType>>(lexicalGlobalObject, throwScope, impl.externalDeviceType())));
}

JSC_DEFINE_CUSTOM_GETTER(jsMediaControlsHost_externalDeviceType, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMediaControlsHost>::get<jsMediaControlsHost_externalDeviceTypeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "externalDeviceType");
}

static inline JSValue jsMediaControlsHost_controlsDependOnPageScaleFactorGetter(JSGlobalObject& lexicalGlobalObject, JSMediaControlsHost& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLBoolean>(lexicalGlobalObject, throwScope, impl.controlsDependOnPageScaleFactor())));
}

JSC_DEFINE_CUSTOM_GETTER(jsMediaControlsHost_controlsDependOnPageScaleFactor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMediaControlsHost>::get<jsMediaControlsHost_controlsDependOnPageScaleFactorGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "controlsDependOnPageScaleFactor");
}

static inline bool setJSMediaControlsHost_controlsDependOnPageScaleFactorSetter(JSGlobalObject& lexicalGlobalObject, JSMediaControlsHost& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLBoolean>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setControlsDependOnPageScaleFactor(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMediaControlsHost_controlsDependOnPageScaleFactor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMediaControlsHost>::set<setJSMediaControlsHost_controlsDependOnPageScaleFactorSetter>(*lexicalGlobalObject, thisValue, encodedValue, "controlsDependOnPageScaleFactor");
}

static inline JSValue jsMediaControlsHost_shadowRootCSSTextGetter(JSGlobalObject& lexicalGlobalObject, JSMediaControlsHost& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLDOMString>(lexicalGlobalObject, throwScope, impl.shadowRootCSSText())));
}

JSC_DEFINE_CUSTOM_GETTER(jsMediaControlsHost_shadowRootCSSText, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMediaControlsHost>::get<jsMediaControlsHost_shadowRootCSSTextGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "shadowRootCSSText");
}

static inline JSC::EncodedJSValue jsMediaControlsHostPrototypeFunction_sortedTrackListForMenu1Body(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSMediaControlsHost>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto trackList = convert<IDLInterface<TextTrackList>>(*lexicalGlobalObject, argument0.value(), [](JSC::JSGlobalObject& lexicalGlobalObject, JSC::ThrowScope& scope) { throwArgumentTypeError(lexicalGlobalObject, scope, 0, "trackList", "MediaControlsHost", "sortedTrackListForMenu", "TextTrackList"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLSequence<IDLInterface<TextTrack>>>(*lexicalGlobalObject, *castedThis->globalObject(), impl.sortedTrackListForMenu(*trackList))));
}

static inline JSC::EncodedJSValue jsMediaControlsHostPrototypeFunction_sortedTrackListForMenu2Body(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSMediaControlsHost>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto trackList = convert<IDLInterface<AudioTrackList>>(*lexicalGlobalObject, argument0.value(), [](JSC::JSGlobalObject& lexicalGlobalObject, JSC::ThrowScope& scope) { throwArgumentTypeError(lexicalGlobalObject, scope, 0, "trackList", "MediaControlsHost", "sortedTrackListForMenu", "AudioTrackList"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLSequence<IDLInterface<AudioTrack>>>(*lexicalGlobalObject, *castedThis->globalObject(), impl.sortedTrackListForMenu(*trackList))));
}

static inline JSC::EncodedJSValue jsMediaControlsHostPrototypeFunction_sortedTrackListForMenuOverloadDispatcher(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSMediaControlsHost>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    size_t argsCount = std::min<size_t>(1, callFrame->argumentCount());
    if (argsCount == 1) {
        JSValue distinguishingArg = callFrame->uncheckedArgument(0);
        if (distinguishingArg.isObject() && asObject(distinguishingArg)->inherits<JSTextTrackList>(vm))
            RELEASE_AND_RETURN(throwScope, (jsMediaControlsHostPrototypeFunction_sortedTrackListForMenu1Body(lexicalGlobalObject, callFrame, castedThis)));
        if (distinguishingArg.isObject() && asObject(distinguishingArg)->inherits<JSAudioTrackList>(vm))
            RELEASE_AND_RETURN(throwScope, (jsMediaControlsHostPrototypeFunction_sortedTrackListForMenu2Body(lexicalGlobalObject, callFrame, castedThis)));
    }
    return argsCount < 1 ? throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject)) : throwVMTypeError(lexicalGlobalObject, throwScope);
}

JSC_DEFINE_HOST_FUNCTION(jsMediaControlsHostPrototypeFunction_sortedTrackListForMenu, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSMediaControlsHost>::call<jsMediaControlsHostPrototypeFunction_sortedTrackListForMenuOverloadDispatcher>(*lexicalGlobalObject, *callFrame, "sortedTrackListForMenu");
}

static inline JSC::EncodedJSValue jsMediaControlsHostPrototypeFunction_displayNameForTrackBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSMediaControlsHost>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto track = convert<IDLNullable<IDLUnion<IDLInterface<TextTrack>, IDLInterface<AudioTrack>>>>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLDOMString>(*lexicalGlobalObject, impl.displayNameForTrack(WTFMove(track)))));
}

JSC_DEFINE_HOST_FUNCTION(jsMediaControlsHostPrototypeFunction_displayNameForTrack, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSMediaControlsHost>::call<jsMediaControlsHostPrototypeFunction_displayNameForTrackBody>(*lexicalGlobalObject, *callFrame, "displayNameForTrack");
}

static inline JSC::EncodedJSValue jsMediaControlsHostPrototypeFunction_setSelectedTextTrackBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSMediaControlsHost>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto track = convert<IDLNullable<IDLInterface<TextTrack>>>(*lexicalGlobalObject, argument0.value(), [](JSC::JSGlobalObject& lexicalGlobalObject, JSC::ThrowScope& scope) { throwArgumentTypeError(lexicalGlobalObject, scope, 0, "track", "MediaControlsHost", "setSelectedTextTrack", "TextTrack"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    throwScope.release();
    impl.setSelectedTextTrack(WTFMove(track));
    return JSValue::encode(jsUndefined());
}

JSC_DEFINE_HOST_FUNCTION(jsMediaControlsHostPrototypeFunction_setSelectedTextTrack, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSMediaControlsHost>::call<jsMediaControlsHostPrototypeFunction_setSelectedTextTrackBody>(*lexicalGlobalObject, *callFrame, "setSelectedTextTrack");
}

static inline JSC::EncodedJSValue jsMediaControlsHostPrototypeFunction_updateTextTrackContainerBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSMediaControlsHost>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    throwScope.release();
    impl.updateTextTrackContainer();
    return JSValue::encode(jsUndefined());
}

JSC_DEFINE_HOST_FUNCTION(jsMediaControlsHostPrototypeFunction_updateTextTrackContainer, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSMediaControlsHost>::call<jsMediaControlsHostPrototypeFunction_updateTextTrackContainerBody>(*lexicalGlobalObject, *callFrame, "updateTextTrackContainer");
}

static inline JSC::EncodedJSValue jsMediaControlsHostPrototypeFunction_enteredFullscreenBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSMediaControlsHost>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    throwScope.release();
    impl.enteredFullscreen();
    return JSValue::encode(jsUndefined());
}

JSC_DEFINE_HOST_FUNCTION(jsMediaControlsHostPrototypeFunction_enteredFullscreen, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSMediaControlsHost>::call<jsMediaControlsHostPrototypeFunction_enteredFullscreenBody>(*lexicalGlobalObject, *callFrame, "enteredFullscreen");
}

static inline JSC::EncodedJSValue jsMediaControlsHostPrototypeFunction_exitedFullscreenBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSMediaControlsHost>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    throwScope.release();
    impl.exitedFullscreen();
    return JSValue::encode(jsUndefined());
}

JSC_DEFINE_HOST_FUNCTION(jsMediaControlsHostPrototypeFunction_exitedFullscreen, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSMediaControlsHost>::call<jsMediaControlsHostPrototypeFunction_exitedFullscreenBody>(*lexicalGlobalObject, *callFrame, "exitedFullscreen");
}

static inline JSC::EncodedJSValue jsMediaControlsHostPrototypeFunction_generateUUIDBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSMediaControlsHost>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLDOMString>(*lexicalGlobalObject, impl.generateUUID())));
}

JSC_DEFINE_HOST_FUNCTION(jsMediaControlsHostPrototypeFunction_generateUUID, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSMediaControlsHost>::call<jsMediaControlsHostPrototypeFunction_generateUUIDBody>(*lexicalGlobalObject, *callFrame, "generateUUID");
}

static inline JSC::EncodedJSValue jsMediaControlsHostPrototypeFunction_base64StringForIconNameAndTypeBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSMediaControlsHost>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 2))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto iconName = convert<IDLDOMString>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument1 = callFrame->uncheckedArgument(1);
    auto iconType = convert<IDLDOMString>(*lexicalGlobalObject, argument1.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLDOMString>(*lexicalGlobalObject, impl.base64StringForIconNameAndType(WTFMove(iconName), WTFMove(iconType)))));
}

JSC_DEFINE_HOST_FUNCTION(jsMediaControlsHostPrototypeFunction_base64StringForIconNameAndType, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSMediaControlsHost>::call<jsMediaControlsHostPrototypeFunction_base64StringForIconNameAndTypeBody>(*lexicalGlobalObject, *callFrame, "base64StringForIconNameAndType");
}

static inline JSC::EncodedJSValue jsMediaControlsHostPrototypeFunction_formattedStringForDurationBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSMediaControlsHost>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto durationInSeconds = convert<IDLUnrestrictedDouble>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLDOMString>(*lexicalGlobalObject, impl.formattedStringForDuration(WTFMove(durationInSeconds)))));
}

JSC_DEFINE_HOST_FUNCTION(jsMediaControlsHostPrototypeFunction_formattedStringForDuration, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSMediaControlsHost>::call<jsMediaControlsHostPrototypeFunction_formattedStringForDurationBody>(*lexicalGlobalObject, *callFrame, "formattedStringForDuration");
}

#if ENABLE(MEDIA_CONTROLS_CONTEXT_MENUS)
static inline JSC::EncodedJSValue jsMediaControlsHostPrototypeFunction_showMediaControlsContextMenuBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSMediaControlsHost>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 3))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto target = convert<IDLInterface<HTMLElement>>(*lexicalGlobalObject, argument0.value(), [](JSC::JSGlobalObject& lexicalGlobalObject, JSC::ThrowScope& scope) { throwArgumentTypeError(lexicalGlobalObject, scope, 0, "target", "MediaControlsHost", "showMediaControlsContextMenu", "HTMLElement"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument1 = callFrame->uncheckedArgument(1);
    auto options = convert<IDLJSON>(*lexicalGlobalObject, argument1.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument2 = callFrame->uncheckedArgument(2);
    auto callback = convert<IDLCallbackFunction<JSVoidCallback>>(*lexicalGlobalObject, argument2.value(), *castedThis->globalObject(), [](JSC::JSGlobalObject& lexicalGlobalObject, JSC::ThrowScope& scope) { throwArgumentMustBeFunctionError(lexicalGlobalObject, scope, 2, "callback", "MediaControlsHost", "showMediaControlsContextMenu"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLBoolean>(impl.showMediaControlsContextMenu(*target, WTFMove(options), callback.releaseNonNull()))));
}

JSC_DEFINE_HOST_FUNCTION(jsMediaControlsHostPrototypeFunction_showMediaControlsContextMenu, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSMediaControlsHost>::call<jsMediaControlsHostPrototypeFunction_showMediaControlsContextMenuBody>(*lexicalGlobalObject, *callFrame, "showMediaControlsContextMenu");
}

#endif

JSC::IsoSubspace* JSMediaControlsHost::subspaceForImpl(JSC::VM& vm)
{
    auto& clientData = *static_cast<JSVMClientData*>(vm.clientData);
    auto& spaces = clientData.subspaces();
    if (auto* space = spaces.m_subspaceForMediaControlsHost.get())
        return space;
    static_assert(std::is_base_of_v<JSC::JSDestructibleObject, JSMediaControlsHost> || !JSMediaControlsHost::needsDestruction);
    if constexpr (std::is_base_of_v<JSC::JSDestructibleObject, JSMediaControlsHost>)
        spaces.m_subspaceForMediaControlsHost = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, vm.destructibleObjectHeapCellType.get(), JSMediaControlsHost);
    else
        spaces.m_subspaceForMediaControlsHost = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, vm.cellHeapCellType.get(), JSMediaControlsHost);
    auto* space = spaces.m_subspaceForMediaControlsHost.get();
IGNORE_WARNINGS_BEGIN("unreachable-code")
IGNORE_WARNINGS_BEGIN("tautological-compare")
    void (*myVisitOutputConstraint)(JSC::JSCell*, JSC::SlotVisitor&) = JSMediaControlsHost::visitOutputConstraints;
    void (*jsCellVisitOutputConstraint)(JSC::JSCell*, JSC::SlotVisitor&) = JSC::JSCell::visitOutputConstraints;
    if (myVisitOutputConstraint != jsCellVisitOutputConstraint)
        clientData.outputConstraintSpaces().append(space);
IGNORE_WARNINGS_END
IGNORE_WARNINGS_END
    return space;
}

void JSMediaControlsHost::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSMediaControlsHost*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

bool JSMediaControlsHostOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, AbstractSlotVisitor& visitor, const char** reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSMediaControlsHostOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsMediaControlsHost = static_cast<JSMediaControlsHost*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsMediaControlsHost->wrapped(), jsMediaControlsHost);
}

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<MediaControlsHost>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to MediaControlsHost.
    static_assert(!std::is_polymorphic<MediaControlsHost>::value, "MediaControlsHost is polymorphic but the IDL claims it is not");
    return createWrapper<MediaControlsHost>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, MediaControlsHost& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}

MediaControlsHost* JSMediaControlsHost::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSMediaControlsHost*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}

#endif // ENABLE(MEDIA_CONTROLS_SCRIPT)
