/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEB_AUDIO)

#include "JSWebKitAudioPannerNode.h"

#include "ActiveDOMObject.h"
#include "DOMIsoSubspaces.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMOperation.h"
#include "JSDOMWrapperCache.h"
#include "JSDistanceModelType.h"
#include "JSPanningModelType.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Functions

static JSC_DECLARE_HOST_FUNCTION(jsWebKitAudioPannerNodePrototypeFunction_setPosition);
static JSC_DECLARE_HOST_FUNCTION(jsWebKitAudioPannerNodePrototypeFunction_setOrientation);
static JSC_DECLARE_HOST_FUNCTION(jsWebKitAudioPannerNodePrototypeFunction_setVelocity);

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsWebKitAudioPannerNodeConstructor);
static JSC_DECLARE_CUSTOM_GETTER(jsWebKitAudioPannerNode_panningModel);
static JSC_DECLARE_CUSTOM_SETTER(setJSWebKitAudioPannerNode_panningModel);
static JSC_DECLARE_CUSTOM_GETTER(jsWebKitAudioPannerNode_distanceModel);
static JSC_DECLARE_CUSTOM_SETTER(setJSWebKitAudioPannerNode_distanceModel);
static JSC_DECLARE_CUSTOM_GETTER(jsWebKitAudioPannerNode_refDistance);
static JSC_DECLARE_CUSTOM_SETTER(setJSWebKitAudioPannerNode_refDistance);
static JSC_DECLARE_CUSTOM_GETTER(jsWebKitAudioPannerNode_maxDistance);
static JSC_DECLARE_CUSTOM_SETTER(setJSWebKitAudioPannerNode_maxDistance);
static JSC_DECLARE_CUSTOM_GETTER(jsWebKitAudioPannerNode_rolloffFactor);
static JSC_DECLARE_CUSTOM_SETTER(setJSWebKitAudioPannerNode_rolloffFactor);
static JSC_DECLARE_CUSTOM_GETTER(jsWebKitAudioPannerNode_coneInnerAngle);
static JSC_DECLARE_CUSTOM_SETTER(setJSWebKitAudioPannerNode_coneInnerAngle);
static JSC_DECLARE_CUSTOM_GETTER(jsWebKitAudioPannerNode_coneOuterAngle);
static JSC_DECLARE_CUSTOM_SETTER(setJSWebKitAudioPannerNode_coneOuterAngle);
static JSC_DECLARE_CUSTOM_GETTER(jsWebKitAudioPannerNode_coneOuterGain);
static JSC_DECLARE_CUSTOM_SETTER(setJSWebKitAudioPannerNode_coneOuterGain);

class JSWebKitAudioPannerNodePrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSWebKitAudioPannerNodePrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSWebKitAudioPannerNodePrototype* ptr = new (NotNull, JSC::allocateCell<JSWebKitAudioPannerNodePrototype>(vm.heap)) JSWebKitAudioPannerNodePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSWebKitAudioPannerNodePrototype, Base);
        return &vm.plainObjectSpace;
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSWebKitAudioPannerNodePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSWebKitAudioPannerNodePrototype, JSWebKitAudioPannerNodePrototype::Base);

using JSWebKitAudioPannerNodeDOMConstructor = JSDOMConstructorNotConstructable<JSWebKitAudioPannerNode>;

template<> JSValue JSWebKitAudioPannerNodeDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSAudioNode::getConstructor(vm, &globalObject);
}

template<> void JSWebKitAudioPannerNodeDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSWebKitAudioPannerNode::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(vm, "webkitAudioPannerNode"_s), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSWebKitAudioPannerNodeDOMConstructor::s_info = { "webkitAudioPannerNode", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebKitAudioPannerNodeDOMConstructor) };

/* Hash table for prototype */

static const HashTableValue JSWebKitAudioPannerNodePrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitAudioPannerNodeConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "panningModel", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitAudioPannerNode_panningModel), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebKitAudioPannerNode_panningModel) } },
    { "distanceModel", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitAudioPannerNode_distanceModel), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebKitAudioPannerNode_distanceModel) } },
    { "refDistance", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitAudioPannerNode_refDistance), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebKitAudioPannerNode_refDistance) } },
    { "maxDistance", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitAudioPannerNode_maxDistance), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebKitAudioPannerNode_maxDistance) } },
    { "rolloffFactor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitAudioPannerNode_rolloffFactor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebKitAudioPannerNode_rolloffFactor) } },
    { "coneInnerAngle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitAudioPannerNode_coneInnerAngle), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebKitAudioPannerNode_coneInnerAngle) } },
    { "coneOuterAngle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitAudioPannerNode_coneOuterAngle), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebKitAudioPannerNode_coneOuterAngle) } },
    { "coneOuterGain", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitAudioPannerNode_coneOuterGain), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebKitAudioPannerNode_coneOuterGain) } },
    { "setPosition", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsWebKitAudioPannerNodePrototypeFunction_setPosition), (intptr_t) (3) } },
    { "setOrientation", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsWebKitAudioPannerNodePrototypeFunction_setOrientation), (intptr_t) (3) } },
    { "setVelocity", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsWebKitAudioPannerNodePrototypeFunction_setVelocity), (intptr_t) (3) } },
};

const ClassInfo JSWebKitAudioPannerNodePrototype::s_info = { "webkitAudioPannerNode", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebKitAudioPannerNodePrototype) };

void JSWebKitAudioPannerNodePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSWebKitAudioPannerNode::info(), JSWebKitAudioPannerNodePrototypeTableValues, *this);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSWebKitAudioPannerNode::s_info = { "webkitAudioPannerNode", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebKitAudioPannerNode) };

JSWebKitAudioPannerNode::JSWebKitAudioPannerNode(Structure* structure, JSDOMGlobalObject& globalObject, Ref<WebKitAudioPannerNode>&& impl)
    : JSAudioNode(structure, globalObject, WTFMove(impl))
{
}

void JSWebKitAudioPannerNode::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

    static_assert(!std::is_base_of<ActiveDOMObject, WebKitAudioPannerNode>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

}

JSObject* JSWebKitAudioPannerNode::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSWebKitAudioPannerNodePrototype::create(vm, &globalObject, JSWebKitAudioPannerNodePrototype::createStructure(vm, &globalObject, JSAudioNode::prototype(vm, globalObject)));
}

JSObject* JSWebKitAudioPannerNode::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSWebKitAudioPannerNode>(vm, globalObject);
}

JSValue JSWebKitAudioPannerNode::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSWebKitAudioPannerNodeDOMConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

template<> inline JSWebKitAudioPannerNode* IDLAttribute<JSWebKitAudioPannerNode>::cast(JSGlobalObject& lexicalGlobalObject, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSWebKitAudioPannerNode*>(JSC::getVM(&lexicalGlobalObject), JSValue::decode(thisValue));
}

template<> inline JSWebKitAudioPannerNode* IDLOperation<JSWebKitAudioPannerNode>::cast(JSGlobalObject& lexicalGlobalObject, CallFrame& callFrame)
{
    return jsDynamicCast<JSWebKitAudioPannerNode*>(JSC::getVM(&lexicalGlobalObject), callFrame.thisValue());
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitAudioPannerNodeConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSWebKitAudioPannerNodePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSWebKitAudioPannerNode::getConstructor(JSC::getVM(lexicalGlobalObject), prototype->globalObject()));
}

static inline JSValue jsWebKitAudioPannerNode_panningModelGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLEnumeration<PanningModelType>>(lexicalGlobalObject, throwScope, impl.panningModel())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitAudioPannerNode_panningModel, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitAudioPannerNode>::get<jsWebKitAudioPannerNode_panningModelGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "panningModel");
}

static inline bool setJSWebKitAudioPannerNode_panningModelSetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioPannerNode& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto optionalNativeValue = parseEnumeration<PanningModelType>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    if (UNLIKELY(!optionalNativeValue))
        return false;
    auto nativeValue = optionalNativeValue.value();
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setPanningModel(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSWebKitAudioPannerNode_panningModel, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSWebKitAudioPannerNode>::set<setJSWebKitAudioPannerNode_panningModelSetter>(*lexicalGlobalObject, thisValue, encodedValue, "panningModel");
}

static inline JSValue jsWebKitAudioPannerNode_distanceModelGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLEnumeration<DistanceModelType>>(lexicalGlobalObject, throwScope, impl.distanceModel())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitAudioPannerNode_distanceModel, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitAudioPannerNode>::get<jsWebKitAudioPannerNode_distanceModelGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "distanceModel");
}

static inline bool setJSWebKitAudioPannerNode_distanceModelSetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioPannerNode& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto optionalNativeValue = parseEnumeration<DistanceModelType>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    if (UNLIKELY(!optionalNativeValue))
        return false;
    auto nativeValue = optionalNativeValue.value();
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setDistanceModel(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSWebKitAudioPannerNode_distanceModel, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSWebKitAudioPannerNode>::set<setJSWebKitAudioPannerNode_distanceModelSetter>(*lexicalGlobalObject, thisValue, encodedValue, "distanceModel");
}

static inline JSValue jsWebKitAudioPannerNode_refDistanceGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnrestrictedDouble>(lexicalGlobalObject, throwScope, impl.refDistance())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitAudioPannerNode_refDistance, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitAudioPannerNode>::get<jsWebKitAudioPannerNode_refDistanceGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "refDistance");
}

static inline bool setJSWebKitAudioPannerNode_refDistanceSetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioPannerNode& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLUnrestrictedDouble>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setRefDistance(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSWebKitAudioPannerNode_refDistance, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSWebKitAudioPannerNode>::set<setJSWebKitAudioPannerNode_refDistanceSetter>(*lexicalGlobalObject, thisValue, encodedValue, "refDistance");
}

static inline JSValue jsWebKitAudioPannerNode_maxDistanceGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnrestrictedDouble>(lexicalGlobalObject, throwScope, impl.maxDistance())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitAudioPannerNode_maxDistance, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitAudioPannerNode>::get<jsWebKitAudioPannerNode_maxDistanceGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "maxDistance");
}

static inline bool setJSWebKitAudioPannerNode_maxDistanceSetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioPannerNode& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLUnrestrictedDouble>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setMaxDistance(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSWebKitAudioPannerNode_maxDistance, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSWebKitAudioPannerNode>::set<setJSWebKitAudioPannerNode_maxDistanceSetter>(*lexicalGlobalObject, thisValue, encodedValue, "maxDistance");
}

static inline JSValue jsWebKitAudioPannerNode_rolloffFactorGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnrestrictedDouble>(lexicalGlobalObject, throwScope, impl.rolloffFactor())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitAudioPannerNode_rolloffFactor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitAudioPannerNode>::get<jsWebKitAudioPannerNode_rolloffFactorGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "rolloffFactor");
}

static inline bool setJSWebKitAudioPannerNode_rolloffFactorSetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioPannerNode& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLUnrestrictedDouble>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setRolloffFactor(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSWebKitAudioPannerNode_rolloffFactor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSWebKitAudioPannerNode>::set<setJSWebKitAudioPannerNode_rolloffFactorSetter>(*lexicalGlobalObject, thisValue, encodedValue, "rolloffFactor");
}

static inline JSValue jsWebKitAudioPannerNode_coneInnerAngleGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnrestrictedDouble>(lexicalGlobalObject, throwScope, impl.coneInnerAngle())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitAudioPannerNode_coneInnerAngle, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitAudioPannerNode>::get<jsWebKitAudioPannerNode_coneInnerAngleGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "coneInnerAngle");
}

static inline bool setJSWebKitAudioPannerNode_coneInnerAngleSetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioPannerNode& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLUnrestrictedDouble>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setConeInnerAngle(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSWebKitAudioPannerNode_coneInnerAngle, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSWebKitAudioPannerNode>::set<setJSWebKitAudioPannerNode_coneInnerAngleSetter>(*lexicalGlobalObject, thisValue, encodedValue, "coneInnerAngle");
}

static inline JSValue jsWebKitAudioPannerNode_coneOuterAngleGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnrestrictedDouble>(lexicalGlobalObject, throwScope, impl.coneOuterAngle())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitAudioPannerNode_coneOuterAngle, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitAudioPannerNode>::get<jsWebKitAudioPannerNode_coneOuterAngleGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "coneOuterAngle");
}

static inline bool setJSWebKitAudioPannerNode_coneOuterAngleSetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioPannerNode& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLUnrestrictedDouble>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setConeOuterAngle(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSWebKitAudioPannerNode_coneOuterAngle, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSWebKitAudioPannerNode>::set<setJSWebKitAudioPannerNode_coneOuterAngleSetter>(*lexicalGlobalObject, thisValue, encodedValue, "coneOuterAngle");
}

static inline JSValue jsWebKitAudioPannerNode_coneOuterGainGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnrestrictedDouble>(lexicalGlobalObject, throwScope, impl.coneOuterGain())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitAudioPannerNode_coneOuterGain, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitAudioPannerNode>::get<jsWebKitAudioPannerNode_coneOuterGainGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "coneOuterGain");
}

static inline bool setJSWebKitAudioPannerNode_coneOuterGainSetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioPannerNode& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLUnrestrictedDouble>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setConeOuterGain(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSWebKitAudioPannerNode_coneOuterGain, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSWebKitAudioPannerNode>::set<setJSWebKitAudioPannerNode_coneOuterGainSetter>(*lexicalGlobalObject, thisValue, encodedValue, "coneOuterGain");
}

static inline JSC::EncodedJSValue jsWebKitAudioPannerNodePrototypeFunction_setPositionBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSWebKitAudioPannerNode>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 3))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto x = convert<IDLUnrestrictedFloat>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument1 = callFrame->uncheckedArgument(1);
    auto y = convert<IDLUnrestrictedFloat>(*lexicalGlobalObject, argument1.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument2 = callFrame->uncheckedArgument(2);
    auto z = convert<IDLUnrestrictedFloat>(*lexicalGlobalObject, argument2.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    throwScope.release();
    impl.setPosition(WTFMove(x), WTFMove(y), WTFMove(z));
    return JSValue::encode(jsUndefined());
}

JSC_DEFINE_HOST_FUNCTION(jsWebKitAudioPannerNodePrototypeFunction_setPosition, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSWebKitAudioPannerNode>::call<jsWebKitAudioPannerNodePrototypeFunction_setPositionBody>(*lexicalGlobalObject, *callFrame, "setPosition");
}

static inline JSC::EncodedJSValue jsWebKitAudioPannerNodePrototypeFunction_setOrientationBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSWebKitAudioPannerNode>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 3))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto x = convert<IDLUnrestrictedFloat>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument1 = callFrame->uncheckedArgument(1);
    auto y = convert<IDLUnrestrictedFloat>(*lexicalGlobalObject, argument1.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument2 = callFrame->uncheckedArgument(2);
    auto z = convert<IDLUnrestrictedFloat>(*lexicalGlobalObject, argument2.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    throwScope.release();
    impl.setOrientation(WTFMove(x), WTFMove(y), WTFMove(z));
    return JSValue::encode(jsUndefined());
}

JSC_DEFINE_HOST_FUNCTION(jsWebKitAudioPannerNodePrototypeFunction_setOrientation, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSWebKitAudioPannerNode>::call<jsWebKitAudioPannerNodePrototypeFunction_setOrientationBody>(*lexicalGlobalObject, *callFrame, "setOrientation");
}

static inline JSC::EncodedJSValue jsWebKitAudioPannerNodePrototypeFunction_setVelocityBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSWebKitAudioPannerNode>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 3))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto x = convert<IDLUnrestrictedFloat>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument1 = callFrame->uncheckedArgument(1);
    auto y = convert<IDLUnrestrictedFloat>(*lexicalGlobalObject, argument1.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument2 = callFrame->uncheckedArgument(2);
    auto z = convert<IDLUnrestrictedFloat>(*lexicalGlobalObject, argument2.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    throwScope.release();
    impl.setVelocity(WTFMove(x), WTFMove(y), WTFMove(z));
    return JSValue::encode(jsUndefined());
}

JSC_DEFINE_HOST_FUNCTION(jsWebKitAudioPannerNodePrototypeFunction_setVelocity, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSWebKitAudioPannerNode>::call<jsWebKitAudioPannerNodePrototypeFunction_setVelocityBody>(*lexicalGlobalObject, *callFrame, "setVelocity");
}

JSC::IsoSubspace* JSWebKitAudioPannerNode::subspaceForImpl(JSC::VM& vm)
{
    auto& clientData = *static_cast<JSVMClientData*>(vm.clientData);
    auto& spaces = clientData.subspaces();
    if (auto* space = spaces.m_subspaceForWebKitAudioPannerNode.get())
        return space;
    static_assert(std::is_base_of_v<JSC::JSDestructibleObject, JSWebKitAudioPannerNode> || !JSWebKitAudioPannerNode::needsDestruction);
    if constexpr (std::is_base_of_v<JSC::JSDestructibleObject, JSWebKitAudioPannerNode>)
        spaces.m_subspaceForWebKitAudioPannerNode = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, vm.destructibleObjectHeapCellType.get(), JSWebKitAudioPannerNode);
    else
        spaces.m_subspaceForWebKitAudioPannerNode = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, vm.cellHeapCellType.get(), JSWebKitAudioPannerNode);
    auto* space = spaces.m_subspaceForWebKitAudioPannerNode.get();
IGNORE_WARNINGS_BEGIN("unreachable-code")
IGNORE_WARNINGS_BEGIN("tautological-compare")
    void (*myVisitOutputConstraint)(JSC::JSCell*, JSC::SlotVisitor&) = JSWebKitAudioPannerNode::visitOutputConstraints;
    void (*jsCellVisitOutputConstraint)(JSC::JSCell*, JSC::SlotVisitor&) = JSC::JSCell::visitOutputConstraints;
    if (myVisitOutputConstraint != jsCellVisitOutputConstraint)
        clientData.outputConstraintSpaces().append(space);
IGNORE_WARNINGS_END
IGNORE_WARNINGS_END
    return space;
}

void JSWebKitAudioPannerNode::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSWebKitAudioPannerNode*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7WebKitAudioPannerNode@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore21WebKitAudioPannerNodeE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<WebKitAudioPannerNode>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    const void* actualVTablePointer = getVTablePointer(impl.ptr());
#if PLATFORM(WIN)
    void* expectedVTablePointer = __identifier("??_7WebKitAudioPannerNode@WebCore@@6B@");
#else
    void* expectedVTablePointer = &_ZTVN7WebCore21WebKitAudioPannerNodeE[2];
#endif

    // If this fails WebKitAudioPannerNode does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(std::is_polymorphic<WebKitAudioPannerNode>::value, "WebKitAudioPannerNode is not polymorphic");

    // If you hit this assertion you either have a use after free bug, or
    // WebKitAudioPannerNode has subclasses. If WebKitAudioPannerNode has subclasses that get passed
    // to toJS() we currently require WebKitAudioPannerNode you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<WebKitAudioPannerNode>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, WebKitAudioPannerNode& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}


}

#endif // ENABLE(WEB_AUDIO)
